<?php
// SNMP WALK CONFIG WIZARD
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: snmpwalk.inc.php 867 2012-05-21 16:01:37Z nscott $

include_once(dirname(__FILE__).'/../configwizardhelper.inc.php');

// run the initialization function
reflector_configwizard_init();

function reflector_configwizard_init(){
	
	$name="reflector";
	
	$args=array(
		CONFIGWIZARD_NAME => $name,
		CONFIGWIZARD_TYPE => CONFIGWIZARD_TYPE_MONITORING,
        COMPONENT_VERSION => '0.1',
		CONFIGWIZARD_DESCRIPTION => "Scan Nagios Reflector for hosts/services to monitor.",
		CONFIGWIZARD_DISPLAYTITLE => "Nagios Reflector",
		CONFIGWIZARD_FUNCTION => "reflector_configwizard_func",
		CONFIGWIZARD_PREVIEWIMAGE => "reflector-wizard.png",
		);
		
	register_configwizard($name,$args);
	}



function reflector_configwizard_func($mode="",$inargs=null,&$outargs,&$result){

	$wizard_name="reflector";

	// initialize return code and output
	$result=0;
	$output="";
	
	// initialize output args - pass back the same data we got
	$outargs[CONFIGWIZARD_PASSBACK_DATA]=$inargs;


	switch($mode){
		case CONFIGWIZARD_MODE_GETSTAGE1HTML:
		
			$reflectoraddress=grab_array_var($inargs,"reflectoraddress","reflector.nagios.com");
            $token=grab_array_var($inargs,"token","");
            $usessl=grab_array_var($inargs,"usessl","http://");
            $usessl_checked=$usessl =="http://" ? "" : "checked='checked'";
			$output='

	<div class="sectionTitle">Reflector Information</div>
	<input type="hidden" name="usessl" id="usessl" value="https://"/>
    <input type="hidden" name="reflectoraddress" id="reflectoraddress" value="'.htmlentities($reflectoraddress).'" />
	<p><!--notes--></p>			
			
	<table>
	<!--
    <tr>
	<td>
	<label>Reflector Address:</label><br class="nobr" />
	</td>
	<td>
<input type="text" size="40" name="reflectoraddress" id="reflectoraddress" value="'.htmlentities($reflectoraddress).'" class="textfield" /><br class="nobr" />
	The IP address or fully qualified DNS name of the reflector server.
	</td>
	</tr>
    <tr>
	<td>
	<label>Use SSL:</label><br class="nobr" />
	</td>
	<td>
<input type="checkbox" name="usessl" id="usessl" value="https://" class="checkbox" '.$usessl_checked.' /><br class="nobr" />
	</td>
	</tr>
    -->
    <tr>
	<td>
	<label>Token:</label><br class="nobr" />
	</td>
	<td>
<input type="text" size="10" name="token" id="token" value="'.htmlentities($token).'" class="textfield" />
	
	</td>
	</tr>
    <tr>
    <td colspan="2">If you don\'t have a token you can register <br>for a token at the <strong><a href="https://reflector.nagios.com" target="_blank">Nagios Reflector</a></strong> site.</td>
    </tr>

	</table>
	

	
	<div id="reflector-throbber" style="visibility: hidden; background-color: white; border: 1px solid black; opacity: 0.9; padding: 20px; position: absolute; text-align: center; top: 200px; width: 500px; z-index: 1; display: none;">
		<div class="message" style="width: 450px;">
		<ul class="infoMessage">
		<li><b>Scanning Reflector - Please wait...</b></li>
		</ul>
		<!--<img src="'.theme_image("throbber1.gif").'">-->
		</div>
	</div>
	
	<script type="text/javascript">
	$(document).ready(function(){
		$("#configWizardForm").submit(function() {
			$("#reflector-throbber").css("display", "block");
			$("#reflector-throbber").css("visibility", "visible");
			//return false;
			});
		});
	</script>

			';
			break;
			
		case CONFIGWIZARD_MODE_VALIDATESTAGE1DATA:
		
			//sleep(10);
		
			// get variables that were passed to us
			$reflectoraddress=grab_array_var($inargs,"reflectoraddress","reflector.nagios.com");
            $token=grab_array_var($inargs,"token","");
            $usessl=grab_array_var($inargs,"usessl","http://");
			
			
			// check for errors
			$errors=0;
			$errmsg=array();
			//$errmsg[$errors++]="Address: '$address'";
			if(have_value($reflectoraddress)==false)
				$errmsg[$errors++]="No reflector address specified.";
            if(!have_value($token))
                $errmsg[$errors++]="Token must be specified.";
				
			if($errors>0){
				$outargs[CONFIGWIZARD_ERROR_MESSAGES]=$errmsg;
				$result=1;
				}
                
                
            
			if($errors>0){
				$outargs[CONFIGWIZARD_ERROR_MESSAGES]=$errmsg;
				$result=1;
				}
            
			break;
			
		case CONFIGWIZARD_MODE_GETSTAGE2HTML:
		
			//print_r($inargs);
		
			// get variables that were passed to us
			$reflectoraddress=grab_array_var($inargs,"reflectoraddress","reflector.nagios.com");
            $token=grab_array_var($inargs,"token","");
            $usessl=grab_array_var($inargs,"usessl","http://");
            $reflectorobjects=grab_array_var($inargs,"reflectorobjects","");
            // START THE SCAN!
            $url=$usessl;
            $url.=$reflectoraddress."/nrdp/";
            
            $postdata = http_build_query(
                array(
                    'cmd' => 'gethostservicelist',
                    'token' => $token
                )
            );

            $opts = array('http' =>
                array(
                    'method'  => 'POST',
                    'header'  => 'Content-type: application/x-www-form-urlencoded',
                    'content' => $postdata
                )
            );

            $context  = stream_context_create($opts);
            
			$reflectorresult=file_get_contents($url, false, $context);
            if(!$reflectorresult)
                $errmsg[$errors++]="Could not connect to reflector server.";
            else {
                $reflectorobjects=simplexml_load_string($reflectorresult);
                
                
            }    
			// print_r($reflectorobjects);
			
						
			
			
			
		
			$output='
			
		<input type="hidden" name="token" value="'.htmlentities($token).'">
		<input type="hidden" name="reflectoraddress" value="'.htmlentities($reflectoraddress).'">
        <input type="hidden" name="usessl" value="'.htmlentities($usessl).'">


	';
	
	if ($reflectorobjects->message == "BAD TOKEN"){
        $output.='
		
		<p>
		The token you provided is not recognized on the reflector.
		</p>
		
		<p>
		You may click back change your settings</a>.
		</p>

	<div id="reflector-throbber" style="visibility: hidden; background-color: white; border: 1px solid black; opacity: 0.9; padding: 20px; position: absolute; text-align: center; top: 200px; width: 500px; z-index: 1; display: none;">
		<div class="message" style="width: 450px;">
		<ul class="infoMessage">
		<li><b>Trying the scan again - Please wait...</b></li>
		</ul>
		<!--<img src="'.theme_image("throbber1.gif").'">-->
		</div>
	</div>
	
	<script type="text/javascript">
	$(document).ready(function(){
		$("#retry").click(function() {
			$("#reflector-throbber").css("display", "block");
			$("#reflector-throbber").css("visibility", "visible");
			//return false;
			});
		});
	</script>

		';
    
    
    }
    else if(count($reflectorobjects->items->host)==0){
		$output.='
		
		<p>
		No results were returned from a scan of the reflector.  This may be due to the fact that the reflector has not received any data yet, or you specified  incorrect scan settings.
		</p>
		
		<p>
		You may either <a href="javascript: history.go(-1)">change your settings</a> or <a href="javascript:location.reload(true)" id="retry">try the same scan again</a>.
		</p>

	<div id="reflector-throbber" style="visibility: hidden; background-color: white; border: 1px solid black; opacity: 0.9; padding: 20px; position: absolute; text-align: center; top: 200px; width: 500px; z-index: 1; display: none;">
		<div class="message" style="width: 450px;">
		<ul class="infoMessage">
		<li><b>Trying the scan again - Please wait...</b></li>
		</ul>
		<!--<img src="'.theme_image("throbber1.gif").'">-->
		</div>
	</div>
	
	<script type="text/javascript">
	$(document).ready(function(){
		$("#retry").click(function() {
			$("#reflector-throbber").css("display", "block");
			$("#reflector-throbber").css("visibility", "visible");
			//return false;
			});
		});
	</script>

		';
		}
		
	else{

		$output.='

		<div class="sectionTitle">Reflector Services</div>
		
		<p>Select the hosts found on the reflector you would like to monitor.</p>
		
	<script type="text/javascript">
	$(document).ready(function(){
		$("#checkall").click(function(){
			var checked_status = this.checked;
			$("input[type=\'checkbox\']").each(function(){
				this.checked = checked_status;
				});
			});
        $(".checkall").click(function(){
			var checked_status = this.checked;
            var check_class = this.id;
			$("."+check_class).each(function(){
				this.checked = checked_status;
				});
			});
		});
        
	</script>

	
	<table class="standardtable">
	<thead>
	<tr><th>Host</th><th><input type="checkbox" id="checkall"></th><th>Service</th><th>Last Seen</th></tr>
	</thead>
	<tbody>';

	$newobjects=$reflectorobjects->items->host;

		
	$current_host=0;
	$displayed=0;
	foreach($newobjects as $arr){
        $hn=$arr->name;
		$svcs=$arr->service;
		$total_services=count($svcs)-1;
		
		// skip if host/service already exists
		
		if($total_services>0){
			$missing=0;
			foreach($svcs as $sarr){
                $sn = $sarr->name;
                    if(service_exists($hn,$sn)==true){
                        $total_services--;
                        continue;
                    }
				$missing++;
				}
			if($missing==0)
				continue;
			}
		if($total_services==0 && host_exists($hn)==true)
			continue;	
		$displayed++;
		
		if($current_host>0)
			$output.= "<tr><td colspan='4'></td></tr>";

		$output.= "<tr>";
		
		$output.= "<td rowspan='".($total_services+1)."'>".$hn."</td>";
        $output.= "<td><input type='checkbox' class='checkall' id='$current_host' name='host[".$hn."]'></td>";
		$output.= "<td>-</td>";
		$output.= "<td>".$arr->service->received."</td>";

		$output.= "</tr>";
		
        
		if($total_services>0){
			foreach($svcs as $sarr){
                $sn = $sarr->name;
				if(service_exists($hn,$sn)==true || $sn=='')
					continue;
			
				$output.= "<tr>";
                $output.= "<td><input type='checkbox' class='$current_host' name='host[".$hn."][".$sn."]'></td>";
				$output.= "<td>".$sn."</td>";
				$output.= "<td>".$sarr->received."</td>";
				$output.= "</tr>";
				}
			}
		
		$current_host++;
		}
	if($displayed==0){
		$output.= "<tr><td colspan='4'>No unconfigured reflector objects found.</td></tr>";
		}
    $output.= "</tbody>";
    $output.= "</table>";

		}
			break;
			
		case CONFIGWIZARD_MODE_VALIDATESTAGE2DATA:
		
			//print_r($inargs);
		
			// get variables that were passed to us
			$reflectoraddress=grab_array_var($inargs,"reflectoraddress");
			$token=grab_array_var($inargs,"token");
            $usessl=grab_array_var($inargs,"http://");
            $host=grab_array_var($inargs,"host");
			
			// check for errors
			$errors=0;
			$errmsg=array();
            foreach($host as $hostname=>$svc){
			if(is_valid_host_name($hostname)==false)
				$errmsg[$errors++]="Invalid host name.";
            }
			if(count($host)==0)
				$errmsg[$errors++]="You have not selected any hosts to monitor.";

			if($errors>0){
				$outargs[CONFIGWIZARD_ERROR_MESSAGES]=$errmsg;
				$result=1;
				}
				
			break;

			
		case CONFIGWIZARD_MODE_GETSTAGE3HTML:
		
			// get variables that were passed to us
			$reflectoraddress=grab_array_var($inargs,"reflectoraddress");
			$token=grab_array_var($inargs,"token");
            $usessl=grab_array_var($inargs,"usessl");
            $host=grab_array_var($inargs,"host");

          
			
			$output='
			
		<input type="hidden" name="token" value="'.htmlentities($token).'">
		<input type="hidden" name="reflectoraddress" value="'.htmlentities($reflectoraddress).'">
        <input type="hidden" name="usessl" value="'.htmlentities($usessl).'">
        <input type="hidden" name="hosts_serial" value="'.base64_encode(serialize($host)).'">

		
			';
			break;
			
		case CONFIGWIZARD_MODE_VALIDATESTAGE3DATA:
				
			break;
			
		case CONFIGWIZARD_MODE_GETFINALSTAGEHTML:
			
			$output='
			
			';
			break;
			
		case CONFIGWIZARD_MODE_GETOBJECTS:
		
			$reflectoraddress=grab_array_var($inargs,"reflectoraddress");
			$token=grab_array_var($inargs,"token");
            $usessl=grab_array_var($inargs,"http://");
            $hosts_serial=grab_array_var($inargs,"hosts_serial","");
			$hosts=unserialize(base64_decode($hosts_serial));
				
			
			$objs=array();
			
            foreach($hosts as $hostname => $svcobj){
            
			if(!host_exists($hostname)){
				$objs[]=array(
					"type" => OBJECTTYPE_HOST,
					"use" => "xiwizard_reflector_host",
					"host_name" => $hostname,
					"address" => $hostname,
					"icon_image" => "reflector-wizard.png",
					"statusmap_image" => "reflector-wizard.png",
                    "check_command" => "check_xi_reflector!".$reflectoraddress."!".$token,
					"_xiwizard" => $wizard_name,
					);
				}
				
			// see which services we should monitor
            if ($svcobj){
                foreach($svcobj as $service => $svcargs){
                

                                        
                    $objs[]=array(
                        "type" => OBJECTTYPE_SERVICE,
                        "host_name" => $hostname,
                        "service_description" => $service,
                        "use" => "xiwizard_reflector_service",
                        "check_command" => "check_xi_reflector!".$reflectoraddress."!".$token."!".$service,
                        "_xiwizard" => $wizard_name,
                        );		
                    }
            }
			}
				
			//echo "OBJECTS:<BR>";
			//print_r($objs);
			//exit();
			
			// return the object definitions to the wizard
			$outargs[CONFIGWIZARD_NAGIOS_OBJECTS]=$objs;
		
			break;
			
		default:
			break;			
		}
		
	return $output;
	}
	

?>